package assignments.product;

import java.util.Random;
import java.util.Scanner;

import static java.lang.System.*;
import static java.lang.Math.*;

/*
 * Simplified text based (i.e. non graphical) version of the Dice Wars game
 * For a full graphical version, see http://www.gamedesign.jp/flash/dice/dice.html (or other)
 *
 * Some rule simplification
 * - No limit of dices in a country
 * - Distribution of earned dices may be "somewhat" random.
 * - Game over when a player lost all countries
 * - Player with most countries wins (or dices? or a combination? You find a measure)
 *
 *  Plan and Process: Compare Tic Tac Toe from exercises
 */
public class DiceWars {

    public static void main(String[] args) {
        new DiceWars().program();
    }

    void program() {
        Random rand = new Random();

        // The players of the game (mostly referenced by index)
        String[] players = {"pelle", "fia", "lisa"};
        // A map with nine countries, named by their index (0-8)
        // Leading 1:s because can't have leading 0 (just skip the ones when processing)
        // 114 says: The country 0 has border to countries 1 and 4.
        // Number of countries is a multiple of players, they all get the same numbers of countries
        int[] map = {114, 1024, 115, 146, 101357, 12487, 137, 14568, 157};
        // This is the owners of the countries. Country 0 is owned by player pelle (players[0])
        int[] owners = {0, 1, 2, 1, 2, 0, 0, 1, 2};
        // This is the number of dices for a country. Country 1 has 3 dices.
        int[] dices = {2, 3, 2, 3, 1, 3, 1, 1, 3};

        out.println("Welcome to Dice Wars \"lite!\"");
        out.println();

        int attacker = rand.nextInt(players.length);
        plotMap(map, owners, dices, players);


        // ****** Write out code here  ******
        // You should use functional decomposition i.e. find a top level
        // method. Then, which methods should be used by the top level method?
        // Then, which methods should be used by methods used by top level etc.
        // Draw a sketch on paper!


        out.println("Game over");
        //out.println("Winner is " + players[winner]);
    }


    // ---- Write your methods below this -----------------------------------

    // Start with this one! Is will say "yes" f two countries have a border
    boolean hasBorder(int i, int j, int[]map){
        return false;   // TODO
    }








    // ----  Nothing to do for you below this line  -----

    // Plot map (as a graph) using ASCII chars
    void plotMap(int[] map, int[] owners, int[] dices, String[] players) {
        int n = (int) sqrt(map.length);
        for (int row = 0; row < 2 * n - 1; row += 2) {
            // One row with horizontal connections
            for (int col = 0; col < n; col++) {
                int i = 3 * row / 2 + col;
                out.print(players[owners[i]] + ":" + dices[i]);
                if (hasBorder(i, i + 1, map)) {
                    out.print("--");
                } else {
                    out.print("  ");
                }
            }
            out.println();
            // Another row with vertical connections
            for (int col = 0; col < n; col++) {
                int i = 3 * row / 2 + col;
                if (hasBorder(i, i + n, map)
                        && hasBorder(i, i + n - 1, map)
                        && hasBorder(i, i + n + 1, map)) {
                    out.print("  / | \\ ");
                } else if (hasBorder(i, i + n, map)
                        && hasBorder(i, i + n - 1, map)) {
                    out.print("/  |     ");
                } else if (hasBorder(i, i + n, map)
                        && hasBorder(i, i + n + 1, map)) {
                    out.print("   | \\  ");
                } else if (hasBorder(i, i + n - 1, map)) {
                    out.print(" /      ");
                } else if (hasBorder(i, i + n + 1, map)) {
                    out.print("     \\  ");
                } else if (hasBorder(i, i + n, map)) {
                    out.print("   |    ");
                } else {
                    out.print("         ");
                }
            }
            out.println();
        }
        out.println("-----------------------------------------");
    }
}
