package samples.catchtherain;

import javafx.scene.paint.Color;

/*
 *   A bucket to catch rain drops in
 *
 */
public class Bucket {

    private final Color color;      // Instance variables
    private final double width;
    private final double height;
    private double dx;   // Speed
    private double x;   // Left
    private final double y;   // Top

    public Bucket(double x, double y, double width, double height, Color color) { // Constructor
        this.x = x;
        this.y = y;
        this.width = width;
        this.height = height;
        this.color = color;
    }

    public void move() {
        x += dx;
    }

    public void setSpeed(int dx) {
        this.dx = dx;
    }


    // ------- Collision detection and rendering -----------------

    public Color getColor() {
        return color;
    }

    public double getX() {
        return x;
    }

    public double getY() {
        return y;
    }

    public double getMaxX() {
        return x + width;
    }

    public double getMaxY() {
        return y + height;
    }
}
