package exercises.oo.lcr;

import java.util.Arrays;
import java.util.List;
import java.util.Scanner;

import static java.lang.System.in;
import static java.lang.System.out;

/*
 *  OO-version of command line game LCR form week 1.
 *  Implement it!
 *
 *  See: https://en.wikipedia.org/wiki/LCR_(dice_game)
 *
 *  Sample run:
 *
    LCR Game started
    Commands are: r = roll, q = quit
    olle = 3 fia = 3 lisa = 3
    Player is fia > r
    Result: . R .
    olle = 3 fia = 2 lisa = 4
    Player is olle > r
    Result: . . .
    olle = 3 fia = 2 lisa = 4
    Player is lisa > r
    Result: . . .
    olle = 3 fia = 2 lisa = 4
    Player is fia > r
    Result: . R
    olle = 3 fia = 1 lisa = 5
    Player is olle > r
    Result: . . .
    olle = 3 fia = 1 lisa = 5
    Player is lisa > r
    Result: C L .
    olle = 3 fia = 2 lisa = 3
    Player is fia >

 */
public class LCRGame {

    public static void main(String[] args) {
        new LCRGame().program();
    }

    // Commands
    final String roll = "r";
    final String quit = "q";
    final Scanner scan = new Scanner(in);

    void program() {
        boolean done = false;
        boolean aborted = false;
        Dice dice = new Dice();
        List<Player> ps = Arrays
                .asList(new Player[]{new Player("olle"),
                        new Player("fia"), new Player("lisa")});
        Players players = null; // TODO

        gameStartMsg(players);

        while (!players.hasWinner()) {

            // TODO Game loop
        }

        gameOverMsg(aborted, players);
    }

    // Methods ---------------------------------
    void gameOverMsg(boolean aborted, Players players) {
        if (aborted) {
            out.println("Aborted");
        } else {
            out.println("Game over! Winner is " + players.getWinner().getName());
        }
    }

    void roundMsg(Players players, List<String> result) {
        String msg = "Result: ";
        for( String s : result){
            msg += s + " ";
        }
        //out.println("Result: " + result.get(0) + " " + result.get(1) + " " + result.get(2));
        out.println(msg);
        statusMsg(players.toList());
    }

    String getCommand(String name) {
        out.print("Player is " + name + " > ");
        return scan.nextLine();  // Will read a String, more later (week 5)
    }

    void gameStartMsg(Players players) {
        out.println("LCR Game started");
        out.println("Commands are: r = roll, q = quit");
        statusMsg(players.toList());
    }

    void statusMsg(List<Player> players) {
        out.println(players.get(0).getName() + " = " + players.get(0).getnChips() +
                " " + players.get(1).getName() + " = " + players.get(1).getnChips() +
                " " + players.get(2).getName() + " = " + players.get(2).getnChips());
    }

    // Classes --------------------------------------------


}
